\documentclass[12pt]{article}
\usepackage[margin=1in]{geometry} 
\usepackage{amsmath,amsthm,amssymb,amsfonts}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{float}
\usepackage{multirow}
\usepackage{hyperref}
\usepackage{appendix}
 
\newcommand{\N}{\mathbb{N}}
\newcommand{\Z}{\mathbb{Z}}
\newcommand{\todo}{\textbf{XXX}}
 
%\newenvironment{problem}[2][Problem]{\begin{trivlist}
%\item[\hskip \labelsep {\bfseries #1}\hskip \labelsep {\bfseries #2.}]}{\end{trivlist}}
%If you want to title your bold things something different just make another thing exactly like this but replace "problem" with the name of the thing you want, like theorem or lemma or whatever
 
\begin{document}
 
%\renewcommand{\qedsymbol}{\filledbox}
%Good resources for looking up how to do stuff:
%Binary operators: http://www.access2science.com/latex/Binary.html
%General help: http://en.wikibooks.org/wiki/LaTeX/Mathematics
%Or just google stuff
 
\title{Rapport de stage}
\author{Angel Ruy-Diaz Rojas}
\date{27/09/2019}
\maketitle
\newpage
%\addcontentsline{toc}{section}{Indice général}
\tableofcontents
\newpage

\listoffigures
\newpage

\listoftables
\newpage
\newpage
\section{Introduction}
ADCS, EPS and thermal simulations are critical domains when talking about space. Simusat is a student-focused satellite simulation software for pre-design of space missions used in cursus in ISAE-Supaero space formation. 

ISAE-SUPAERO is a research and innovation-driven institution of higher education, committed to balancing scientific excellence, academic visibility and proximity to industrial objectives. In order to achieve these goals this institution divide its activity in Six teaching and research departments focus in aerospace system.
 In particular, the following document is based on the work experience in the Department of Aerospace Vehicles Design and Control (DCAS) that supports activities related to design and control during development of aeronautics and space vehicles. The DCAS conducts its own research and is involved in national, European and international research projects and works in three different research groups. In the report presented all the research was done in the Aerospace vehicle design group under the supervision of Professor Thibault Gateau.

In the code of Simusat, there are still evidences of what was written in 1999. It has suffer several big updates and upgrades (see figure \ref{crono}) including the translation of the code to the current language (VB.NET). During the process, some of the functionalities where lost, and the modules where no longer reliable due to the lack of unit test and validation. In addition, the simulation requirements to meet have improved and so, the calculation methods need an update. In 2018, another intern in ISAE-Supaero (Michele Genoni) worked on the ADCS module, validated it and gave Simusat a brand new image. 

 \begin{figure}[h]
	\centering
	\includegraphics[width=0.9\textwidth]{Images/cronology}
 	\caption{Evolution of Simusat.}
 	\label{crono}
\end{figure}

The objective of Simusat is providing an easy to use tool able to return enough accurate results with a simple model to for pre-design phases of satellites and space mission and for pedagogical purposes. To accomplish it, the next step is giving Simusat a thermal analysis module that allows calculating the temperature of the satellite at any point of the orbit it describes. 

The importance of the thermal analysis lies in the delicacy surrounding space missions. Spacecrafts carry with them many equipment including the electronics that make them work, the antennas to communicate or the scientific instruments to fulfil their goal. All of them will only work correctly at a specific range of temperatures and, due to the costs of spacial projects, they will have to last without degradation for the whole life of the satellite, that is measured in years. In addition,, the environment of an orbiting spacecraft is extremely different to the one that can be found in a laboratory, which complicates a lot testing, thus an specific discipline is in charge of obtaining the temperature of each part of the satellite. The spacecraft's environment is vacuum (or almost vacuum if it is in a low earth orbit) at 3$^\circ$K with some celestial corps that either radiate or reflect some energy that works as a source of energy for the vehicle. The other source of energy for the thermal control of the spacecraft is the power dissipated by the electronics. 

To fulfil the goal if having an useful but simple thermal module in Simusat, the principal objectives of the internship are checking and rewriting the thermal module code, validate it through unit and integration tests and providing an updated and deployable version of the software. In the following pages, it will be reflected the working environment, the work done during the four months and the steps to be followed to continue upgrading the software. 


\section{Methodology}
In this section, it will be presented in which framework the work has been developed. It will be presented the working environment as well as how different versions have been managed.

\subsection{Programming environment}
The software Simusat is coded in VB.NET and the last time it had some developing, it was used Visual Studio 2013. To avoid compatibility problems, we decided to continue using that version of Visual Studio instead of using a more recent version. Visual Studio is a Microsoft Windows IDE that allows developing in a sort of languages as C$\#$ or Visual Basic. 

Although the objective was having a multi-platform software, nowadays it is only installable in windows.

\subsection{Forge: ISAE Openforge}
To have control over the different versions, ISAE Openforge is used to host the project. It provides a versioning repository (Git), a wiki, a ticket system... 
ISAE Openforge is a platform that facilitates the collaboration of people working at ISAE. It offers access to Git as well as having a Wiki, a presentation page and other features that were not used in this specific project as task management. The platform is web-based and is used to host the Simusat Project.

\subsection{Git}
Git is a Distributed Version Control System, free and open source, designed to handle everything
from small to very large projects with speed and efficiency.  

Git has remote repository in a server containing the project and developers can have a local repository of the whole project as well. It allows having different branches, both in the shared repository in the server and in the local repository and allows the creation, deletion and merging of different developments in a matter of seconds.

In the project, the existing branches were the Master branch, which contained the last version of the project and a different branch for each one of the developers that have worked on it. A new branch is created for my development from the Master branch. Each time a new deployable version of Simusat was ready, the developer branch was merged with the Master and a tag was created to easily identify it (figure \ref{git}).

 \begin{figure}[h]
	\centering
	\includegraphics[width=0.7\textwidth]{Images/diagrama}
 	\caption{Git branches.}
 	\label{git}
\end{figure}


\subsection{Unit tests and integration tests}
To ensure the robustness of the cod, it is decided to implement unit tests to the thermal module as well as they already existed for other modules of the software. A unit test is a function that determines if a specific part of the code (a function, a sub routine or a whole module) works well. It works comparing if the result of the lines of code tested and the known result are equal within a given tolerance (normally from $10^{-3}$ to $10^{-6}$). This allows to quickly check if the code keeps working well after developing. Finally, the integration test is a test that, in this case, check if the ensemble of the Energy and Thermal modules work properly.




\section{Thermal module of the software}
\subsection{Introduction}
In the industry thermal simulations is done thanks to softwares like Thermica \ref{fig:thermica}, developed by Airbus, or ESATAN-TMS, developed by ITP Engines UK Ltd. under ESA contract. Both of them perform simulations in detail with a high precision but require complicated spacecraft and environment models. The goal of Simusat is not competing with them but providing with a simpler tool able to provide the user with an approximate value of the temperature of the spacecraft at any point of its orbit for pre-design phase and pedagogical purposes. 

 \begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/thermica}
 	\caption{Screen shot of Systema-Thermica \cite{thermica}.}
 	\label{fig:thermica}
\end{figure}

A simplified model will then be implemented to Simusat. In this section, the model will be presented as well as the external data used to model albedo and Earth temperature more accurately. All the add-ons are implemented to be easily adaptable to the necessities.
 
\subsection{Thermal model}
A spacecraft is made of a huge number of elements of different nature that at each instant of time may have different temperatures and that interact between them with energy exchanges of different nature (conduction, convection and radiation). Taking into account the goal of the software (a preliminary analysis) and the complexity of the problem (due to the amount of elements), it is necessary to simplify the problem by modelling it as it is done in \cite{PolyThermo}. 

The model coded is called Lumped Parameter Method. The method consists on dividing the system studied in sufficient thermal nodes (the amount depends on the precision desired). Each node represent an only temperature and it will interact with the rest nodes and the environment through the thermal exchanges.

 \begin{figure}[h]
	\centering
	\includegraphics[width=0.25\textwidth]{Images/Sat-nodes}
 	\caption{Nodes in the thermal model.}
 	\label{fig:sat-node}
\end{figure}

The model implemented in the software consists of a node that represents the whole spacecraft body and a node for each solar panel attached to it. Due to the model, the energy conservation equation becomes, for each one of the nodes and at each moment, a balance of energy inputs and energy outputs that is equal to the storage of energy in the mass. Deriving with respect to time the equation \ref{eq:gen-ener-bal} is obtained:

\begin{equation} \label{eq:gen-ener-bal}
\sum P_{inputs} - \sum P_{outputs}  = C_i \frac{dT_i}{dt}
\end{equation}

Where:

\begin{itemize}
\item $P_{inputs}$ and $P_{outputs}$ are respectively the power inputs and outputs measured in Watts.
\item $C_i$ is the thermal capacity of the node measured in Watts per Kelvin.
\item $\frac{dT_i}{dt}$ is the variation of the node's temperature with time.
\end{itemize}

In the following sections it will be presented how the equation is implemented on the different nodes and how they are solved as well as the different types of heat transfers that may appear on the different nodes.
\subsection{Thermal exchanges} \label{subsec: thermal exchanges}
\subsubsection{Radiation}

Radiative exchanges are those heat transfers between two surfaces that are visible one to each other in vacuum or through a transparent medium. They are related to emission, absorption, reflection and transmission of electromagnetic radiation in the range from ultraviolet to infrared.

Every node in the model is considered to be an opaque body, so the transmission coefficient will be 0 for all. We will pay special attention on the absorbed and emitted radiation by each one of the nodes. 

Every node will emit a heat radiation that follows the Stefan Boltzmann law:

\begin{equation} \label{eq:St-Bolt-law}
\Phi  =S \epsilon \sigma T^4 
\end{equation}

\begin{itemize}
\item $\Phi$ is the emitted radiation in Watts.
\item S is the surface of the node ($m^2$)
\item $\epsilon$ is the emissivity
\item $\sigma$ is the Stefan Boltzmann constant = $5.6704\cdot 10^{-8}  W.m^{-2}.K^{-4}$ 
\end{itemize}

As a simplification, the emissivity will be considerer only as a function of the wavelength $\lambda$ and constant with respect to temperature and the direction of emission. In addition, due to the Kirchhoff's law, for each wavelength, the emissivity will be equal to the absorptivity.

In the space environment, surfaces are exposed to two different electromagnetic spectra that correspond to the of the Sun and the infrared spectrum. This means that two different emissivities, and therefore absorptivities will be considered for each surface. In particular, we will talk about the solar absorptivity $(\alpha_s)$ and the infrared emissivity $(\epsilon_{IR})$.

Another term to be added to the Stefan Boltzmann law is the view factor. This factor takes into account that that all the radiation emitted by a surface 1 is not received by the surface 2. For example, not all the infrared radiation emitted by Earth is received by one spacecraft. This view factor (wit a value always between 0 and 1) is a function of the size of both surfaces and their relative position. The factor represented as $F_{1 \rightarrow 2}$ is defined as the fraction of the total flux emitted by the surface 1 that is received by the surface 2. The view factor $F_{2 \rightarrow 1}$ is defined the other way around and the relation between both is the equation \ref{eq:view-fact-reci}.

\begin{equation} \label{eq:view-fact-reci}
S_1 \cdot F_{1 \rightarrow 2}  =S_2 \cdot F_{2 \rightarrow 1}
\end{equation}

This way, the power emitted by the surface 1 and received by the surface 2 is written as:

\begin{equation}\label{eq:Phi1_2}
\Phi_{1 \rightarrow 2}  = S_1 \cdot F_{1 \rightarrow 2} \cdot \epsilon_1 \sigma T_1^4 = S_2 \cdot F_{2 \rightarrow 1} \cdot \epsilon_1 \sigma T_1^4
\end{equation}
  
In the model, the radiative heat transfers take into account are the reception of solar, albedo and Earth infrared radiation and the radiation emitted from the external surfaces of the spacecraft to the open space. How these are calculated is explained in the following paragraphs.

\vspace{5mm}

\textbf{Note:} Each time the cosine of an angle appears in any of the radiation equations, if it is negative, it is substituted by 0. A negative cosine means that there is no visibility between both bodies, thus the radiation is not possible.

\subsubsection*{Solar radiation}
To model the solar radiation, the Sun will be simplified as a punctual source of radiation located at the center of the real Sun that irradiates a total power of $P_{sun} = 3.8 \cdot 10^{26}\ W$ spread equally in every direction. So, any body with a surface $S_{per}$ perpendicular to the radiation low at a distance $d$ from the Sun will receive the radiation $\Phi_{sun}$ of the equation \ref{eq: sun-rad}. For a flat surface, the perpendicular surface will be $S_{per}= S \cdot cos(\theta)$, where $\theta$ is the angle between the vector normal to de surface and the direction to the sun as in the figure \ref{fig:sun-sat}

\begin{equation} \label{eq: sun-rad}
\Phi_{sun} = S_{per} \phi_{sun}
\end{equation}

Where $\phi_{sun} = \frac{P_{sun}}{4 \pi d^2}$.

    \begin{figure}[h]
	\centering
	\includegraphics[width=0.3\textwidth]{Images/sun-sat}
 	\caption{Configuration satellite-Sun.}
 	\label{fig:sun-sat}
\end{figure}
  
To calculate the power absorbed by each face of each node, the power emitted by the Sun towards each face has to be multiplied by the absorptivity of that face, so the power received will be:

\begin{equation} \label{eq: sun-face}
\Phi_{sun,i} = \alpha_i \cdot S_i \cdot cos{\theta} \cdot \phi_{sun}
\end{equation}   

Where the subindex i denotes the surface to which it is referred.

\subsubsection*{Earth infrared radiation}
The Earth infrared radiation received by each surface of the nodes is calculated using the equation \ref{eq:Phi1_2}. The temperature of the Earth is taken from the CERES data, presented in the section \ref{sec:CERES} and the factor of view is calculated using the table in the appendix D of \cite{EarthIRCFactor} that is reproduced here:

\begin{table}[htb]
\centering
\begin{tabular}{|c|c|c|c|c|c|c|}
\hline
& \multicolumn{6}{c|}{$F_T$} \\
\cline{1-7}
$\ \eta (^\circ)\ $ & 200 km & 500 km & 1000 km & 1500 km & 2000 km & 35786 km\\
\hline \cline{2-7}
\multicolumn{1}{|c||}{0} & 0.9401 & 0.8618 & 0.7527 & 0.6613 & 0.5883 & 0.0239 \\
\hline
\multicolumn{1}{|c||}{30} & 0.8284 & 0.7512 & 0.6522 & 0.5727 & 0.5099 & 0.0208 \\
\hline
\multicolumn{1}{|c||}{60} & 0.6026 & 0.5186 & 0.4216 & 0.3572 & 0.3109 & 0.012 \\
\hline
\multicolumn{1}{|c||}{90} & 0.3476 & 0.2746 & 0.198 & 0.1528 & 0.1228 & 0.0008 \\
\hline
\multicolumn{1}{|c||}{120} & 0.1324 & 0.0875 & 0.0467 & 0.0274 & 0.0166 & 0 \\
\hline
\multicolumn{1}{|c||}{150} & 0.014 & 0.0045 & 0.0006 & 0 & 0 & 0 \\
\hline
\end{tabular}
\caption{Earth-flat plate view factor}
\label{tb:earth-view-factor}
\end{table}

The inputs of the table \ref{tb:earth-view-factor} are $\eta$ (see figure \ref{fig:earth-view-factor}) and the distance to the Earth surface.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.3\textwidth]{Images/earth-view-factor}
 	\caption{Relative position of Earth and spacecraft.}
 	\label{fig:earth-view-factor}
\end{figure}

The implementation of the table in the software is done by importing it as .csv file. After that, a linear interpolation is made both in distance and angle $\eta$ to obtain the view factor of flat plate at an specific distance and relative position. 

With this view factor it will be enough for every surface of the spacecraft as it is conceived in the software. So, the equation \ref{eq:Phi1_2} adapted to this particular case is:

\begin{equation}\label{eq:Phi_earth}
\Phi_{Earth,i}  = S_i \cdot F_{T} \cdot \epsilon_i \sigma T_{earth}^4 
\end{equation}

Where i refers to each surface.

\subsubsection*{Albedo radiation}
The albedo is defined as the solar radiation reflected on the Earth that arrives to the spacecraft. As the radiation comes (indirectly) from the Sun, its spectra is the Sun's one. The albedo radiation will then expressed as a portion of the solar radiation through the albedo coefficient $C_a$. This coefficient strongly depends on the point of the Earth because clouds, water or ice do not reflect the same amount of radiation. The calculation of the albedo coefficient is further discussed in the section \ref{sec:CERES}.

Furthermore, this time the radiation is calculated using the equation \ref{eq:Phi1_2} where $\epsilon_1 \sigma T_1^4$ is substituted by $C_a \phi_{sun}$. The heat transfer is:

\begin{equation} \label{eq: alb-face}
\Phi_{alb,i} = \alpha_i \cdot C_a \phi_{sun} \cdot S_i \cdot F_{aalb,i}
\end{equation}  

Where $F_{alb,i}$ is the factor of view for the albedo.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.3\textwidth]{Images/earth-sat-sun}
 	\caption{Relative position of Earth, Sun and spacecraft.}
 	\label{fig:earth-sat-sun}
\end{figure}

In this particular case, as the Earth is not the direct source of radiation, it is also taken into account the relative position Earth-spacecraft-Sun so that the factor of view is calculated with the equation \ref{eq: fac-view-alb}. As it can be noticed, when the angle $\theta_S$ is higher than 100$^\circ$, the albedo goes to 0.
  
\begin{equation} \label{eq: fac-view-alb}
F_{alb,i} = F_{Earth,i} \cdot cos^{1.5}(0.9\theta_S)
\end{equation} 

\subsubsection*{Radiation towards open space}
The space can be considered to be at a temperature of 3K so in this case, the spacecraft will radiate towards space in the range of infrared. In this case the view factor will be 1 so the radiation that exits each surface of the spacecraft will be:

\begin{equation}\label{eq:Phi-space}
\Phi_{space,i}  = S_i \cdot \epsilon_i \sigma T_{i}^4 
\end{equation}
  
\subsubsection{Conduction}
The heat transfer by conduction is defined as the one that occurs inside a solid body (or an immobile fluid) or between two bodies in physic contact. In the software, due to the Lumped Parameter Method, the only conduction taken into account is the one produced between two bodies (with an homogeneous temperature) through the contact surface between them. For example, there will be conduction through the common surface of a panel and a face of the satellite.

The heat transfer will be modelled as the equation \ref{eq: conduction}, where $K_{1-2}$ is the conduction factor between the nodes, $S$ is the contact surface between them and $T_1$ and $T_2$ are their respective temperatures. $\Phi_{1-2}$ is the heat transfer between the body (node) 1 to the body (node) 2. If it has a positive value, the heat will flow towards 2, whereas if the value is negative, the heat will flow towards 1. 

\begin{equation} \label{eq: conduction}
\Phi_{cond,1-2} = K_{1-2} \cdot S \cdot (T_1 - T_2) 
\end{equation} 

\subsubsection{Convection}
Convection will be neglected throughout this software. Outside the spacecraft a total vacuum is considered and inside it no convection is possible as the whole body will be 1 node itself. In more realistic models, there may be convection inside the body due to the gasification of some materials (phenomena of evaporation of certain materials due to the low pressure of the environment) or with the atmosphere in very low altitude orbits. However, all this effects are neglected in this model.

\subsection{Implementation}
The implementation of the model consists on applying the corresponding heat transfers to the different nodes' energy balance and solving it. This subsection will be divided intro the different sort of nodes that may appear (central body and solar panels) and the resolution of the energy balance.

\subsubsection{Central body}
The central body, conceived always as a regular square prism, will receive the radiation from the Sun, the Earth infrared and the albedo radiation in all of its faces (subject to the visibility of each face to the different sources). In addition, it will radiate towards the space from every face. Said that, the energy balance for the central body is:

\begin{equation} \label{eq: bal-body}
\sum_{face\ i=1}^{6} (\Phi_{sun,i} + \Phi_{Earth,i} + \Phi_{alb,i} - \Phi_{space,i} )= C_{body} \frac{dT_{body}}{dt}
\end{equation}

In every $\Phi$ that appears on the equation, the temperature is $T_{body}$ (the body is a node itself). However, different $\alpha_s$ and $\epsilon_{IR}$ may appear in each face to simulate different materials or thermal protection.

\subsubsection{Solar panel}
In the software, three different type of solar panels are coded (see figure \ref{fig:solar-pan-types}). Although all of them have the same basic energy balance, the type 2 panel will also have a interaction with the central body that will be shown in the next section. 

\begin{figure}[h]
	\centering
	\includegraphics[width=0.7\textwidth]{Images/solar-pan-types}
 	\caption{Types of solar panel in the software.}
 	\label{fig:solar-pan-types}
\end{figure}

Each panel has 2 faces: one with the solar cells (front face) and the back face that do not have solar cells. This implies that, as in the case of the body, each face will have its own absorptivity and emissivity. Finally, generally speaking, the energy balance for a solar panel is:

\begin{equation} \label{bal-pan}
\sum_{face\ i=1}^{2} (\Phi_{sun,i} + \Phi_{Earth,i} + \Phi_{alb,i} - \Phi_{space,i} )= C_{panel} \frac{dT_{panel}}{dt}
\end{equation} 

\subsubsection{Central body - solar panel interaction}
There will only be an interaction between those nodes if the solar panel is of type 2. Although in real life there is an interaction with every sort of panel (and even between panels), in the software the model is simplified to only take into account the type 2, which have a surface in common with the satellite. The interaction is taken into account by adding some terms to the left term of the balance in both nodes.

\subsubsection*{Central body balance (with interaction)}
In the central body, it will be taken into account that only a part of the face/s that have a type 2 solar panel is still visible and the the radiative and conduction exchanges with the solar panel. With this into mind, the left term of the energy balance for a face that has a type 2 panel is:

\begin{equation} \label{bal-sat-pan}
Max(0,\ 1-\frac{S_{panel}}{S_{i}})[\Phi_{sun,i} + \Phi_{Earth,i} + \Phi_{alb,i}] - \Phi_{space,i} + \Phi_{panel}+\Phi_{cond,panel-body}
\end{equation} 

Where $\Phi_{panel}$ is the panel's back face radiation towards the space (but it is now received by the central body face) and $\Phi_{cond,panel-body}$ the conduction transfer (being the positive sign towards the central body) where the surface is the surface in common, that is, the surface of the panel.

\subsubsection*{Type 2 solar panel balance (with interaction)}
In the solar panel, the changes in the balance only occurs in terms of the back face. The  terms associated to that face are substituted by the following:

\begin{equation} \label{bal-pan-sat}
\Phi_{space,i} - \Phi_{panel}-\Phi_{cond,panel-body}
\end{equation} 

The input power is the radiation emitted by the body and the output powers are the terms that where added to the central body in the precedent section.

\subsubsection{Energy balance solution} 
To solve the differential equation, the derivative of the temperature will be discretized so it turns into an increment. To obtain the evolution of temperature between to dates, a time step is chosen and the following algorithm is performed for each instant of time. To solve it, it is necessary to have an initial temperature of the central body and of each one the solar panels. Knowing the temperature at the instant $t$, the temperature at the instant $t+dt$ is calculated:

\begin{itemize}
\item Starting with the central body, all the radiative flows are calculated using $T_{body}(t)$.
\item Interaction with panels is added (using also their temperature in the instant $t$).
\item The increment of temperature is calculated as $\Delta T_{body} =\frac{\Delta t}{C} \sum_{face\ i=1}^{6} X$ where X is the left term of the balance as calculated in the previous sections.
\item $T_{body}(t+\Delta t) = T_{body}(t) + \Delta T_{body}$.
\item Panels balance is done equivalently but, if there is interaction with the body, the temperature used for it is $T_{body}(t+\Delta t)$.
\item Position of the spacecraft and celestial bodies is updated and the whole process is repeated moving on a time step
\end{itemize}



\subsection{CERES model for albedo and Earth infra-red radiation} \label{sec:CERES}
\subsubsection{Introduction}
Clouds and the Earth's Radiant Energy System (CERES) experiment is one of the scientific satellite instruments developed for the Earth Observation System by NASA. This experiments measures, among other data, the albedo from top of the atmosphere and Earth IR flux. More information about the CERES experiment can be found in \cite{CERESFaQ}.

The data taken for the software is the gathered by CERES from \date{01/01/2007} to the \date{31/12/2011}. This data has been averaged to obtain a table that which shows the average value of the albedo coefficient and the Earth temperature for every  10$^\circ$ latitude and for each month. Those tables can be found in \cite{CERESmodel}. A clearer representation of both tables is reproduced in the figures \ref{fig:CER-alb-rep} and \ref{fig:CER-ir-rep} that are an adaptation for the ones found in \cite{CERESmodel}.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.7\textwidth]{Images/CERES-repr-albedo-mod}
 	\caption{Representation of albedo coefficient distribution in latitude for each month adapted from \cite{CERESmodel}.}
 	\label{fig:CER-alb-rep}
\end{figure}

\begin{figure}[h]
	\centering
	\includegraphics[width=0.7\textwidth]{Images/CERES-repr-ir-mod}
 	\caption{Representation of Earth temperature (K) distribution in latitude for each month adapted from \cite{CERESmodel}.}
 	\label{fig:CER-ir-rep}
\end{figure}

This data allows having a more accurate model that will improve the accuracy of the calculations in orbits with an inclination different to 0$^\circ$ (for equatorial orbits, a constant albedo coefficient and Earth temperature is enough). In addition, the monthly data allows more accuracy in near to polar orbits, as the albedo coefficient goes to 0 in the northern pole in winter and the southern pole in summer (northern hemisphere seasons).

\subsubsection{Implementation of the model}

The CERES data is implemented in the software as a .csv table where the month and the latitude will be the inputs and the albedo coefficient will be the output. To add realism to the results, a linear interpolation is done for the latitudes to have a continuous curve. However, the pass from one month to another is done sharply. 

In the figure \ref{fig:alb-flux-2months} it can be seen the evolution of the albedo flux received by a face pointing nadir of a satellite in a circular polar orbit. The simulation has been made to show the effect of changing month. One can note that there is not a discontinuity although the albedo coefficient has changed in the middle of the simulation.

 \begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/alb-flux-2months}
 	\caption{Albedo flux received by a face pointing Nadir in a circular polar orbit.}
 	\label{fig:alb-flux-2months}
\end{figure}

\subsection{Update of the tab \textit{Environment}}
As different models have been added for albedo flow and infra-red flow from Earth, it is necessary to give the user the possibility to choose which thermal model they want to use. Mainly, the choice is between using the CERES model (already explained in the section \ref{sec:CERES} or a custom model where it is possible to give a value for each month to the earth constant and the albedo coefficient. The window before the update was the one in figure \ref{fig:old-env-win}. There it is only possible to customize the monthly template, but it is not possible to decide if you want to use CERES data.  

\begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/old-environment-window-det}
 	\caption{Old \textit{Environment} tab inside Mission Design (detail).}
 	\label{fig:old-env-win}
\end{figure}

The window is therefore updated to allow this choice. As can be seen in the figure \ref{fig:new-env-win} two check-boxes have been added in the corresponding sections to make the decision to use CERES data. In addition, if it is checked, the customization is blocked as seen in the last section of the figure \ref{fig:new-env-win}.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/new-environment-window-det}
 	\caption{New \textit{Environment} tab inside Mission Design (detail).}
 	\label{fig:new-env-win}
\end{figure}

Other features that have been added are new display options. Due to the format of the CERES data (table with latitude and month as inputs), in the graph \textit{monthly data} what is displayed is the average value of each month. This average value is also used to calculate the infrared flux if CERES is used for albedo and isotherm model is used for the Earth constant . In addition, another graph has been added that shows the CERES data used for the selected month (see figure \ref{fig:new-env-win-Cg}).

\begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/new-environment-window-CERESgraph-det}
 	\caption{Display of CERES model in the software.}
 	\label{fig:new-env-win-Cg}
\end{figure}  


\subsection{Update of the \textit{Mass, geometry} tab} \label{subsec: update mass geom}

The reason for updating this window is that the number of solar cell string lines of each panel is not defined in the software (see section \ref{subsec:Bug-NbStrings}). It is necessary to allow the user to define and modify this property for each panel. After a study of the possibilities, it is decided to add a button to the satellite configuration tab (figure \ref{fig:old-satconf-win}) 

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\textwidth]{Images/old-satellite-configuration-window-det}
 	\caption{Old Satellite configuration tab (detail).}
 	\label{fig:old-satconf-win}
\end{figure}  

The modification is small visually (see figure \ref{fig:new-satconf-win}). On the other hand, at the software level, it will be necessary to modify some files. First, it is necessary to add the property in the buttons \textit{Add} and \textit{Modify} and add a function to check that the value is correct (a positive integer) in the code of the window. To ensure that the number is an integer, the input is rounded to the closer integer.

In addition, limiting values are added by defining them in the configuration file \textit{conf.json}, adding limiting value variables in \textit{basDeclaration.vb} and reading them in \textit{Utilitaires.vb}.   

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\textwidth]{Images/new-satellite-configuration-window-det}
 	\caption{Updated Satellite configuration tab (detail).}
 	\label{fig:new-satconf-win}
\end{figure}  


\subsection{Unit tests and integration test}
The validation of the module is done through unit tests to check each function and integration tests to check the global behaviour.

Fifteen unit test are coded to check in different cases the view factors, the interpolations in .csv files, the orientation of the faces and the panels towards Earth and Sun, thermal flux calculations, eclipse times and whole orbit temperature calculations.

One integration test is coded that compares a whole report (with checked data) with simulating the same problem again. In addition, two of the fifteen unit test could also be considered as integration tests as they check the calculation of the temperature in every point of an orbit.

In the table \ref{tb:Unit and integration tests run time.}, it can be found the the different tests done to the module and the time they new to be done. As it can be seen there are tests that take less than one millisecond to run and others that need almost a second. The duration is  proportional to the number of internal tests that are done. The fastest tests are those that only check a few points like checking the interpolation of .csv files while the slowest are check full orbits.

The most demanding test (Report$\_$test) corresponds to the integration test, that verifies for a whole orbit all the power and thermal data of the satellite and the four solar panels that it owns.

\begin{table}[htb]
\centering
\resizebox{8.3cm}{!} {
\begin{tabular}{|p{7cm}|p{1.5cm}|}
\hline
Test & Run time \\
\hline 
Albedo$\_$ESA$\_$test & 1ms \\
\hline
Albedo$\_$test & 32ms\\
\hline
Average$\_$Temp$\_$test & 193ms \\
\hline
Avg$\_$ESA$\_$test & $<$1ms\\
\hline
Conf$\_$factor$\_$earth$\_$sphere$\_$test & 5ms \\
\hline 
Conf$\_$factor$\_$rectangle$\_$oneFace$\_$earth$\_$test & 2ms \\
\hline
Earth$\_$Face$\_$angle$\_$test & 95ms\\
\hline
Earth$\_$temp$\_$ESA$\_$test & 1ms\\
\hline
Eclipse$\_$test & 1ms \\
\hline 
Flux$\_$rad$\_$test & $<$1ms \\
\hline
Orbit$\_$Temp$\_$test & 214ms\\
\hline
Report$\_$test & 719ms \\
\hline 
Solar$\_$intensity$\_$test & $<$1ms \\
\hline
Type1$\_$panel$\_$orientation$\_$Sun & 163ms\\
\hline
Type2$\_$panel$\_$orientation$\_$Earth$\_$Sun & 642ms\\
\hline
Type3$\_$panel$\_$orientation$\_$Earth$\_$Sun & 210ms\\
\hline
\end{tabular}
}
\caption{Unit and integration tests run time.}
\label{tb:Unit and integration tests run time.}
\end{table}

As said, the objective of the tests is verifying the code is correct at the present and, in the future, that any development causes a malfunctioning. 


\section{Saved data restructuring}
In Simusat two different type of documents were available to be saved: .att and .orb. The files .att contained all the data concerning the satellite (mass, configuration, solar cells, batteries and thermical data) and the environment data (Solar power, albedo coefficient and Earth IR power) whereas the files .orb contained the orbit parameters and the attitude of the satellite in the orbit. However, this distribution did not make much sense. Taking a look to the distribution of the windows in the main one (figure \ref{fig:old-main}), the environment tab is together with the orbit data tab in a different section of the satellite configuring tabs. In addition, the buttons \textit{New}, \textit{Open} and \textit{Save As...} are in a place that makes the user think that those buttons works for the full project (only going inside the saved file the user realizes what is really saved) but they only work for the .att files. For saving a .orb file it is necessary to open the \textit{Orbit data} and then click on \textit{Export}. 

\begin{figure}[h]
	\centering
	\includegraphics[width=1\textwidth]{Images/old-main}
 	\caption{Main window Simusat 2017 (version 5.0).}
 	\label{fig:old-main}
\end{figure}

The software has suffered some restructuring in these terms. Theses changes are shown in the following subsections.

\subsection{.att files}
In the .att files are name like that because they contain the attitude configuration. However, they mainly contain the data from every subsystem in the satellite in addition to the geometrical data. For this reason, it is decided to change the extension of the files to .sc (from spacecraft) for the files of Simusat 6.0 and later versions.

The change of the file extension comes together with a modification of the content. These new extension files do not include the environment data, as it has nothing to do with the satellite configuration.

Both changes provoke the necessity to modify both reading and writing file functions as well as the Saving Dialog code and the \textit{New file} file (a file that contains the default data that is loaded when clicking on New file). In addition, retrocompatibility is allowed when opening a file. This means that .att are still supported by the new versions of Simusat. However, it is not possible to save files with the old .att extension. The retrocompatibility is possible thanks to an \textit{If} structure that reads the environment lines of the file if the extension is .att and do nothing if the extension is .sc.

Finally, as the environment data is no longer inside \textit{blank$\_$file.sc}, and since the function used to load it is the same as the one used when opening a file, it is necessary to precise on the New file \textit{Sub Procedure} that the extension is .sc to avoid the program to crash trying to read environment data. 

\subsection{.orb files}
The environment data that has been eliminated from .sc files it will now be included in .orb files. Like this, every data that is manipulated in the \textit{Satellite Design} section of the main window is saved in one file (.sc) and the data manipulated in the \textit{Mission Design} window is now saved in a separated file (.orb). This time it is decided not to change the extension of the file. 

Due to this decision, an exception can occur when opening a .orb file: if we open an old Simusat .orb file, the program tries to read the environment lines (that do not exist) and crashes. To handle it, a Try-Catch structure is used.

\subsection{Main window update}
The redistribution of data in the saved files and the accessibility to opening and saving a .orb file motivates an update of the main window of the software. In the version 5.0 of Simusat (the existing version at the beginning of the internship) the main window is the one of the figure \ref{fig:old-main}. The situation of the buttons \textit{New, Open} and \textit{Save as...} takes the user to the idea that clicking on them they act over all the software (although in reality they only act over the \textit{Satellite Design} section), there is no clue that \textit{Mission Design} data is saved apart and the \textit{New} button works, more precisely, as a reset button.

From the version 6.3 and on of the software, the Main window changes to the one in the figure \ref{fig:new-main}. From left to right and from the top to the bottom, the changes performed are the following:

\begin{itemize}
\item Title of the window updated to Simusat 2019
\item \textit{New, Open} and \textit{Save as...} buttons moved inside \textit{Satellite Design} section to indicate that they only act on what is modified there.
\item \textit{New} button changed to \textit{Reset} to avoid confusing users. 
\item Inside \textit{Mission Design} an \textit{Open} and \textit{Save} buttons are included. These buttons are directly related to the \textit{Export} and \textit{Open} buttons inside \textit{Orbit data}. Indeed, the functioning of the new buttons is the following: once it is clicked, it opens the \textit{Orbit data} window and automatically clicks on the corresponding button. Like this, it is avoided having a repeated procedure and turning public a procedure that should not be so.
\end{itemize}

\begin{figure}[h]
	\centering
	\includegraphics[width=1\textwidth]{Images/new-main}
 	\caption{Main window Simusat 2019 (version 6.3 and on).}
 	\label{fig:new-main}
\end{figure}




\section{Bonus development}

\subsection{Shadow background for eclipses in Graphs}
The time a satellite is on an eclipse (the Sun is covered by the Earth from the point of view of the satellite) plays a fundamental role in many calculations, either in attitude control (solar pressure), thermal control (with no solar radiation, the temperature decreases) or the energy management (if the panels do not receive energy, the battery discharges more rapidly). 

\begin{figure}[h]
	\centering
	\includegraphics[width=0.16\textwidth]{Images/Report-eclipse.PNG}
 	\caption{Cells shaded to indicate eclipse.}
 	\label{fig:report-eclipse}
\end{figure}

Due to the importance of the eclipses, it is really interesting knowing whether the satellite is on one or not when performing a simulation. On the reports, the eclipses are shown by shadowing the date cells (see figure \ref{fig:report-eclipse}) but they are not shown in the graphs. To do so, striplines are used to shadow the background. In each time step, a grey stripline with the time step's width will be drawn in the graph if the satellite is on an eclipse. Before drawing a new graph, all the striplines are removed to avoid superposition and to adapt the striplines to the time step (a lower time step means a higher accuracy on the calculation of eclipses). The result of adding the striplines are graphs like the figure \ref{fig:graph-eclipse} that shows, for example, that the temperature drop is due to the eclipse. The background shadow is added in both attitude and power$\&$thermal curves windows.

 \begin{figure}[h]
	\centering
	\includegraphics[width=0.4\textwidth]{Images/Graph-eclipse.PNG}
 	\caption{Background  shaded to indicate eclipse.}
 	\label{fig:graph-eclipse}
\end{figure}

\subsection{Aerodynamic torque correction}
After a validation meeting with the professor who will make use of the software, it is notice a malfunctioning of the aerodynamic torques. After some testing, it is noticed a malfunctioning when modifying the attitude of the satellite (see how it is solved in \ref{sec:Att_mod_bug}) but this do not solve the main problem. The code of the torques was written in 1999 and the equations that appear to calculate the torque have no reference, so, in first terms, it is not possible to check them. There are to things that can be checked: how the aerodynamic force is calculated and how the torque is calculated from the force and the vector to the center of gravity.   

Checking the vector from the center of each face to the center of gravity it is noticed that is only taken into account the perpendicular distance but the fact that both points may not be in line is not taken into account. After modifying the code, the graphs change and they seem to be correct, but without checking if the equation sare correct, the results are not conclusive.

Some research about how to calculate the torques is made on the internet and the monograph \textit{Sapcecraft Aerodynamic Torques} from NASA is found (see \cite{Torques}). In the section 2.4.1 of the monograph appears the following equation to calculate the aerodynamic force:

\begin{equation}\label{eq:aero_torque}
dF=-\rho V^{2}[(2-\sigma_{n}-\sigma_{t})(\vec{e_{v}}\cdot \vec{e_{t}})^{2}\vec{e_{n}}+\sigma_{t}(\vec{e_{v}}\cdot \vec{e_{t}})\vec{e_{v}}]dA
\end{equation}

where:
\begin{itemize}
\item $\rho$ is the density of the air
\item \textit{V} is the spacecraft velocity
\item $\sigma_{n}$ is the normal momentum exchange coefficient
\item $\sigma_{t}$ is the tangential momentum exchange coefficient
\item $\vec{e_{v}}$ is the unit spacecraft velocity vector
\item $\vec{e_{n}}$ is the outward unit vector normal to \textit{dA}
\end{itemize}

To obtain the equation coded in the software (file \textit{basCouples.vb}), the equation \ref{eq:aero_torque} has to be projected to the the vectors normal and tangential to the face. In addition, the velocity that appears in the code is the relative velocity of the spacecraft with respect to the velocity of the atmosphere, which makes sense as in the original equation it is not taken into account the wind. Finally, the momentum exchange coefficients are decided by the user, although the values by default are of the order of the empirical value used in the monograph. 

To sum up, after changing the consideration of the center of gravity position and referencing the equation coded, it can be concluded that the aerodynamic torque well calculated now.


\section{Bug Fixing}
In the following section, it will be presented the bugs solved in the software classified by their severity into minor, major and fatal \cite{bugs}. For an easier reading, each bug will be written divided in problem and solution in several tables. 

\subsection{Fatal bugs}
Fatal bugs are those that cause the software to crash. To full description and solution of the bugs, go to appendice \ref{appendA}

\begin{table}[H]
\centering
\resizebox{16.5cm}{!} {
\begin{tabular}{|p{5.5cm}|p{5.5cm}|p{5.5cm}|}
\hline
\multicolumn{3}{|c|}{\textbf{Fatal Bugs}} \\
\hline
\textbf{Bug Type} & \textbf{Problem} & \textbf{Solution}\\
\hline 
Resetting satellite data. & When we click on \textbf{Reset} the software throws an exception and crashes & Cut and paste the file blank$\_$file.sc in the folder \textit{bin$\/$resources} \\
\hline
Invalid Cast Execption. Unable to convert the string to date. & An exception is thrown when the orbit epoch hour is 23 hours. & Add 1/24 to the Julian day of the orbit epoch for the end date. \\
\hline
Automatic update of \textit{Parameters} of the to-be-plotted list. & If a solar panel is removed or modifid, the Power Graphs window will not update. & Remove every property from the removed panel and change the pointer for the next panels. \\
\hline
Export of \textit{(Power Report)} in Excel format. & The program
does not recognize the number format instructions. & Check the homologue code in {(Attitude Report)} and copy it. \\
\hline

\end{tabular}
}
\caption{Fatal bugs analysis and solution}
\label{tb:fatal-bugs}
\end{table}
	


\subsection{Major bugs}
Major bugs are those that affect to the results although there are no execution problems. To full description and solution of the bugs, go to appendice \ref{appendB}

	
\begin{table}[H]
\centering
\resizebox{16.5cm}{!} {
\begin{tabular}{|p{5.5cm}|p{5.5cm}|p{5.5cm}|}
\hline
\multicolumn{3}{|c|}{\textbf{Major Bugs}} \\
\hline
\textbf{Bug} & \textbf{Problem} & \textbf{Solution}\\
\hline 
Solar panels surface. & The radiation of conduction of any surface panel is zero. & Calculate the surface in the \textit{(Add)} button of the \textit{(Mass, Geometry)} window. \\
\hline
Number of solar cell chains in the solar panels. & Any solar panel added to the spacecraft generates any power. & Add a textbox in the window where the panels are defined to give a value to the property.\\
\hline
Repetition of solar panels allowed if they are modified. & If a solar panel is modified, a superposition of two panels is possible. & Add code to ban that behaviour \\
\hline
Automatic orbit change if no type is selected. & After defining new orbital parameters if we click \textit{Other} or \textit{Play}, the orbit automatically changes to the one by default. & Comment some lines of the code and change it to select the type \textit{(Other}.\\
\hline
Change of satellite’s attitude. & When the attitude of the satellite is changed in one axis, the other one does not adapt. & Adding some lines   to each S\textit{elected Index Changed} event associated with the buttons that sets the axis/direction.\\
\hline
\end{tabular}
}
\caption{Major bugs analysis and solution}
\label{tb:Major-bugs}
\end{table}




\subsection{Minor bugs}
Minor bugs are those that only affect to the user experience although both execution and results are correct. To full description and solution of the bugs, go to appendice \ref{appendC}

	
\begin{table}[H]
\centering
\resizebox{16.5cm}{!} {
\begin{tabular}{|p{5.5cm}|p{5.5cm}|p{5.5cm}|}
\hline
\multicolumn{3}{|c|}{\textbf{Minor bugs}} \\
\hline
\textbf{Bug} & \textbf{Problem} & \textbf{Solution}\\
\hline 
Start and Current dates on the Main window are not updated after modifying
the orbit epoch. & Only the dates (not the time) are updated on the Main window when changing the orbit epoch. & Copying the lines of code that update the time of the orbit epoch in other functions. \\
\hline
Update of simulation dates in the windows Curves and Report & When \textit{Graph} or \textit{Report} windows are updated for the second time , the simulation dates are not updated. &  Create another  \textit{Sub} which updates the date of all windows affected by the bug.\\
\hline
\textit{Curves: Energy} window’s calendar & It is not possible to change the dates using the calendars in the window. & Change the Sub Procedure from \textit{Activated} to \textit{Load}. \\
\hline
Possible items for display in \textit{Curves: Energy} & Each time the window \textit{Curves: Energy} is opened the items are duplicated, triplicated, etc. & Change the type of  \textit{Sub} from \textit{Activated} to \textit{Load}.\\
\hline
\textit{Panels Parameters} are not disabled by default in \textit{Curves} windows. & The desired behaviour is that the panel section is disabled by default even if there are panels. & Add code to do not allow the selection of Panels Parameters and send a message if there are no panels.\\
\hline
Updating the Y axis in the solar flux display. & When displaying environmental data in the tab \textit{Environment},  too high values will not appear because the Y axis’ limit is fixed. & Change the maximum value of the Y axis in the graphical property editor into automatic. \\
\hline
Warning message in attitude configuration window when plotting battery
parameters. & Each time a thermal/energy property is plotted, a value limiter warning message appears on the attitude configuration window &  A new value limiter function is created with the same functionalities but without writing the message.\\
\hline
Orbit file name changes after saving it. & After saving an orbit file, the name of the orbit shown in the window changes to the full path of the file. & Using a System function  which, given a path, returns the file name\\
\hline
Mouse shown when there is an error in the \textit{Energy Report} saving. & When there is an error while saving, the mouse keeps being shown as loading after clicking ok on the error message. & Adding \textit{cursor.default} function.\\
\hline
\end{tabular}
}
\caption{Minor bugs analysis and solution}
\label{tb:Minor-bugs}
\end{table}



\section{Software deployment}
Once all the development has been done, the software need to be usable in any Windows computer. In order to do so, two different versions of the software are available: a standalone version and an installable version. Both versions  contain the same software but differ on the way the software is run in the computer. Both versions include Quickstart manuals, example files and a README.txt that explains to new users how to run the program and the firsts steps towards a simple analysis.

\subsection{Standalone version}
The standalone version allows using the software without installing it, which makes it perfect for users without administrator permissions. It works thanks to having the .exe file and all the libraries in the same folder as well as the necessary files.

The standalone version has been used during the development of the software to test it in other computers inside ISAE-Supaero.

\subsection{Installable version}
Once the development is considered as finished, a installable version of the software is done thanks to the official extension \textit{Microsoft Visual Studio 2013 Installer Projects} for Visual Studio. This extensions allows creating a project whose output will be a .exe and a .msi file that allows installing the software through a setup Wizard. The installation includes creation of a shortcut in the program menu and the desktop. 


\section{Conclusions and future works}
All the objectives presented in the introduction have been fulfilled. The thermal and EPS modules have been proven to be functional thanks to checking the code with the unit tests and a deployable version has been released. In addition, multiple bugs have been solved ensuring a well functioning and a better experience for the user. 

In the line of improving the experience, some extra development has been done like plotting the eclipses on the graphs. In addition, the way the data is saved has been modified to make more intuitive the use of the software leading to a new file extension but  conserving the compatibility with older files.

Finally, the aerodynamic torque calculation has been corrected although it was not in the objectives. Its correction was noticed to be necessary after a test of the software in the hands of the professor that will make use of the product.  

Simusat is now ready to be deployed to fulfil the basic purpose of being used in ISAE-Supaero cursus but there are stills things to work on. 
Firstly, \textit{Events} is still not available in the ADCS module. this feature will allow including events in time to see if the attitude control devices installed in the spacecraft are enough to fulfil its requirements. Secondly, the power diagram is not functional. It lacks including the power module in the main simulation loop (currently power module is only simulated in the corresponding Graphs and Report) to make the whole diagram work. Finally, implementing a more complex thermal model increasing the number of nodes on the central body from one to seven to have more precise results.

\newpage
\bibliography{Bibliography}
\bibliographystyle{ieeetr}

\newpage

\appendix
\appendixpage
\addappheadtotoc
\section{Fatal bugs full description} \label{appendA}
\subsection{Resetting satellite data}
	\subsubsection*{Problem}
Each time we click on \textit{Reset}, the software is designed to call a file named \textit{ blank\_file.cs} where all the default values of the satellite parameters but it throws an exception because it is not able to find the file. 
	\subsubsection*{Solution}
The problem was that this file was not in the right folder. A simple cut and paste of the file to the folder \textit{bin/resources} solves the bug and allows resetting the satellite.

	\subsection{InvalidCastExeption. Unable to convert the string to date}
	\subsubsection*{Problem}
An exception is thrown when the orbit epoch hour is 23 hours.

	\subsubsection*{Solution}
In all \textit{Graph} and \textit{Report} window, the default start and end times are respectively the time of the orbit epoch and plus 1 hour for the end date. This hour addition was made by adding 1 to the hour section, which returned 24 as the hour, which prohibited (see figure \ref{fig:bug-conv-date}).

The solution is to do the format change in two steps, one for the start date and the other for the end date. In the end date process, 1/24 is added to the Julian day of the orbit epoch to add an hour to the date.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.95\textwidth]{Images/Bug-conversion-date}
 	\caption{Error when the start date is 23h.}
 	\label{fig:bug-conv-date}
\end{figure}

	\subsection{Automatic update of \textit{Parameters} of the to-be-plotted list}
	\subsubsection*{Problem}
If we remove or modify a solar panel, if any of its properties was on the list of properties to be plotted in the Power Graphs window, it will not be updated by its own. This may cause from wrong plotting (the panels identifier changes when removing one) to program crash because it is trying to plot something that does not exist.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\textwidth]{Images/Bug-panel-removal}
 	\caption{Items to be plotted evolution when removing a solar panel.}
 	\label{fig:bug-panel-removal}
\end{figure}

	\subsubsection*{Solution}
The logic followed to solve the bug is the following: 
\begin{itemize}
\item Remove from the list every property from the panel removed.
\item If there were more panels with a higher identifying number, the name of the property is changed to modify the panel it is pointing to the original one.
\end{itemize}

	\subsection{Export of \textit{Power Report} in Excel format}
	\subsubsection*{Problem}
An exception is thrown when trying to save a \textit{Power Report} in Excel format. The program does not recognize the number format instructions.

	\subsubsection*{Solution}
The procedure followed was looking at the homologue code in \textit{Attitude Report} to see that the problematic lines where commented. It is checked that the Excel export is well done.

In addition, the function that allows saving into Excel format is improved by adding the option to save either in .xls or .xlsx format.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/Bug-save-excel}
 	\caption{Commented lines to make operative the saving of the report in Excel format.}
 	\label{fig:bug-save-excel}
\end{figure}





\section{Major bugs full description} \label{appendB}

\subsection{Solar panel surface} \label{subsec:Bug-surface}
	\subsubsection*{Problem}
Any solar panel added to the spacecraft receives any radiation or conduction and its temperature is constant. It does not matter the type of panel, the orientation or the orbit described by the spacecraft. It is noticed that the surface of any panel is zero.

	\subsubsection*{Solution}
The problem is that, even if the property \textit{Panel Surface} exists, it is never given a value. The solution is to add a line in the \textit{Add} button code of the \textit{Mass, Geometry} window that states that the surface of each panel is its length times its width.	


	\subsection{Number of solar cell chains in the solar panels} \label{subsec:Bug-NbStrings}
	\subsubsection*{Problem}
Any solar panel added to the spacecraft generates any power. The problem is homologue to the the one about the surface of the panels (see section \ref{subsec:Bug-surface}): the number of solar cells string is never given.

	\subsubsection*{Solution}
The solution is to add a textbox in the window where the panels are defined to give a value to the property. Look at the section \ref{subsec: update mass geom}, where it is shown.

	\subsection{Repetition of solar panel allowed if they are modified}
	\subsubsection*{Problem}
If a solar panel is modified, a superposition of two panels or even having two equal panels (same type and mount face) is possible. The cause is that it is not coded (as it is done for the \textit{Add} button) that a superposition or repetition of panels is forbidden.
	\subsubsection*{Solution}
The solution to the bug is adding the lines of code of the figure \ref{fig:bug-modify-panel}. These lines are similar to the ones that appear on the code of the \textit{Add} adding the fact that the input boxes that exist to create a panel have to be updated even if the modification was not possible (a modification of the mass, the size or the number of strings is never rejected)

\begin{figure}[h]
	\centering
	\includegraphics[width=0.9\textwidth]{Images/Bug-modify-panel}
 	\caption{Code used to avoid superposition or repetition of solar panels.}
 	\label{fig:bug-modify-panel}
\end{figure}

	\subsection{Automatic orbit change if no type is selected}
	\subsubsection*{Problem}
Once the orbital parameters have been defined (not having selected the orbit type), if we click in the type \textit{Other} or we launch the simulation by clicking on \textit{Play} in the \textit{Main} window. In both cases, the orbit automatically changes to the circular orbit defined by default.
	\subsubsection*{Solution}
 To avoid the bug, the lines of code in the figure \ref{fig:bug-act-orbit} were commented to avoid updating the parameters when the \textit{Other} button is checked in the orbit type selection. In addition, it must be coded that in the case where no orbit type has been chosen, the type \textit{Other} will be chosen automatically.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.5\textwidth]{Images/Bug-auto-orbit-change}
 	\caption{Commented code lines to solve the bug that changes the orbital parameters.}
 	\label{fig:bug-act-orbit}
\end{figure}

	\subsection{Change of satellite's attitude} \label{sec:Att_mod_bug}
	\subsubsection*{Problem}
When the attitude of the satellite is changed in the window \textit{Orbit data}, once one of the axis and/or  the direction is modified, the other one changes automatically if they are not compatible (having as primary and secondary axis the same one or trying to have both axis pointing the same direction). The automatic change is only visual, the satellite property is not modified. This error causes problems in the calculation of torques, panels temperatures and everything that needs from the attitude to work.

	\subsubsection*{Solution}
The solution is adding a line of code to each \textit{Selected Index Changed} event associated with each button that sets the other axis/direction to the one that is shown on the window. The line added in each event is of the sort of: Satellite.primaryAxis = cmbPrinAxis.Text. That is to say, set the property to the content of the text box.




\section{Minor bugs full description} \label{appendC}

\subsection{Start and Current dates on the Main window are not updated after modifying the orbit epoch}
	\subsubsection*{Problem}
Only the dates (not the time) are updated on the Main window when changing the orbit epoch.

	\subsubsection*{Solution} 
The bug is solved with by copying the lines of the figure \ref{fig:bug-date-main} that update the time of the orbit epoch in the event \textit{leave text box} and in the function \textit{norad to orbit} that translates NORAD elements to orbital elements.


\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/Bug-dates-Main}
 	\caption{Code lines to update the dates in the Main window.}
 	\label{fig:bug-date-main}
\end{figure}

\subsection{Update of simulation dates in the windows \textit{Curves} and \textit{Report}}
	\subsubsection*{Problem}
When \textit{Graph} or \textit{Report} windows are opened for the first time, the start and end dates are updated in accordance with the orbit epoch. If the epoch is changed for a second time, the simulation dates are not updated.
	
	\subsubsection*{Solution}
 The error comes from the fact that the dates are only updated once because the Sub Procedure Load, where the update is made, is only activated the first time the window is opened. The solution is to create another \textit{Sub}, the one in figure \ref{fig:bug-act-dates}, which updates the date of all windows affected by the bug. This \textit{Sub} is called in all the \textit{Sub Procedures} that change the epoch of the orbit: Norad orbit selection and direct date and time selection (in both dd/mm/yyyyyy and Norad format).

\begin{figure}[h]
	\centering
	\includegraphics[width=0.9\textwidth]{Images/Bug-act-dates}
 	\caption{Sub Procedure to update the dates in the Curves and Report windows.}
 	\label{fig:bug-act-dates}
\end{figure}

	
	\subsection{\textit{Curves: Energy} window's calendar}  \label{subsec:Bug-Calendier}
	\subsubsection*{Problem}
It is not possible to change the start and end dates of the report using the calendars on the window. It is necessary to write the date.

\subsubsection*{Solution}
The problem is due to the Sub Procedure \textit{Activated} that is in the window's code. This procedure does what is inside it each time the window is activated. 

Each time a date was selected in the calendar, the window was activated again changing the date to the default one coded.

The solution is changing the Sub Procedure from \textit{Activated} to \textit{Load} that is only activated the first time the window is opened.  

	\subsection{Possible items for display in \textit{Curves: Energy}}
	\subsubsection*{Problem}
Each time the window \textit{Curves: Energy} is opened, the list of displayable items increases as seen in the figure \ref{fig:bug-items-powergraph}. The increase is due to a duplication, triplication, etc. of the items in it.
\subsubsection*{Solution}
 The error is the same as in the case of date selection (section \ref{subsec:Bug-Calendier}): the addition of items to the list is done in the Sub Procedure \textit{Activated}. The solution is therefore the same as in the case of the calendar: change the type of \textit{Sub} from \textit{Activated} to \textit{Load} so that items will be added only once.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/Bug-Items-PowerGraph}
 	\caption{items that can be displayed when the window is opened 1, 2 and 3 times.}
 	\label{fig:bug-items-powergraph}
\end{figure} 


	\subsection{\textit{Panels Parameters} are not disabled by default in \textit{Curves} windows}
\subsubsection*{Problem}
	In the thermal and energy graph window, when the window is opened and the satellite has no solar panels, the panel parameters section is not disabled by default (figure \ref{fig:bug-pwrgraph-1}) and it is possible to enable and disable it without restrictions. The desired behaviour is that the panel section is disabled by default even if there are panels or not. Thus, if there are no panels, it must be impossible to activate this section. 

\begin{figure}[h]
	\centering
	\includegraphics[width=0.4\textwidth]{Images/Bug-PwrGraph-1}
 	\caption{Selection of panel parameters if no panel exists.}
 	\label{fig:bug-pwrgraph-1}
\end{figure}

\subsubsection*{Solution}
To make the section disabled by default, all that has to be done is to change the position of the lines that allow to do so. Actually there was an \textit{Exit Sub} for the case where there were no panels in the Sub Procedure \textit{Load} of the window. If the lines are placed before the instruction \textit{Exit Sub}, it will always work well.

To avoid activation if no panel exists, it must acted on the \textit{Sub} that is activated when clicking on the selection point. Here it is needed to add a few lines (figure \ref{fig:bug-pwrgraph-11}) that do not allow the selection of \textit{Panels Parameters} at the same time as the user receives a message that there is no panel in the satellite. 

\begin{figure}[h]
	\centering
	\includegraphics[width=0.6\textwidth]{Images/Bug-PwrGraph-11}
 	\caption{Lines added to prevent the activation of panel parameters.}
 	\label{fig:bug-pwrgraph-11}
\end{figure}

Finally, the button must be deselected if all panels are removed. To do this, all that has to be done is calling the \textit{Sub} activated when you check/uncheck one of the buttons (\textit{optParPan CheckedChanged}) in the procedure of the \textit{Remove} button in the satellite configuration window. Since \textit{optParPan CheckedChanged} is private, an indirect call is made from \textit{Remove}: if the number of panels is 0, \textit{General Parameters} is checked (\textit{frmGraphPwr.optParGen.Checked = True}), which calls the desired procedure if the checked button was that of the panel parameters. Otherwise, if \textit{General Parameters} was already checked, no further action is needed.  

\subsection{Updating the Y axis in the solar flux display}
	\subsubsection*{Problem}
	When displaying environmental data in the tab \textit{Environment}, if values are too high, they will not appear on the graph because the Y axis' maximum value is fixed.
	
	\subsubsection*{Solution}
Provoking an automatic update using the maximum solar flux (it will always be the property with the highest values) as a guide required changing the code automatically written by Visual Studio by making public the property \textit{Maximum}. This change caused an Error Message even if it worked well. Finally, it was decided to simply change the maximum value of the Y axis in the graphical property editor into automatic as it can be seen in the figure \ref{fig:bug-env-axis}.  

\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{Images/Bug-env-axis}
 	\caption{path to Y axis properties.}
 	\label{fig:bug-env-axis}
\end{figure}



	\subsection{Warning message in attitude configuration window when plotting battery parameters}
\subsubsection*{Problem}
Each time a thermal/energy property is plotted, a value limiter warning message appears on the attitude configuration window. Any of the mentioned properties implies a modification in any of the parameters on the mentioned window. 
\subsubsection*{Solution}
It is noticed that in the batteries code a value limiter function is called. This function was designed to be used only in the Attitude configuration window as inside the function it included the writing of the message. A new function is created with the same functionalities but writing the message.

	\subsection{Orbit file name changes after saving it}
	\subsubsection*{Problem}
After saving an orbit file, the name of the orbit shown in the window changes to the full path of the file saved.
\subsubsection*{Solution}
This was occasioned by a bad attempt to update the name of the orbit to the name given to the file saved. This is solved by using the System function \textit{Path.GetFileName}, which, given a path, returns the file name. 


\subsection{Mouse shown when there is an error in the \textit{Energy Report} saving}
	\subsubsection*{Problem}
	When there is an error while saving the mouse keeps being shown as loading instead of the default pointer after clicking ok on the error message.
	\subsubsection*{Solution}
The bug was caused by the missing of the line that change the mouse shape to its default.
In addition, a message has been added to warn the user that the saving has not been made as can be seen in the figure \ref{fig:bug-thinking-mouse}
\begin{figure}[h]
	\centering
	\includegraphics[width=0.4\textwidth]{Images/Bug-thinking-mouse}
 	\caption{Added lines to return the mouse to its default shape and warn the user.}
 	\label{fig:bug-thinking-mouse}
\end{figure}
%Thermical nodes suggested:\\ Specific heats:
%\begin{itemize}
%    \item central body: 50000 J/deg
%    \item solar panels: 2500 J/deg
%    \item upside and downside: 1500 J/deg
%    \item conductive coupling b/w links panels and central body: 4W/m$^2$/deg
%\end{itemize}


%\vspace{5mm}

%\begin{center}
%\begin{tabular}{c|c|c}
%\centering
%    \textbf{Material} & \textbf{$\alpha$} & \textbf{$\epsilon$} \\
%    White paint & 0.2 & 0.9 \\
%    Black paint & 0.95 & 0.9 \\
%    MLI & 0.25 & 0.05 \\
%    Solar Panels & 0.8 & 0.9
%\end{tabular}
%\end{center}

%\vspace{5mm}




%\begin{figure}[H]
%        \centering
%        \includegraphics[width=13cm]{imagesNEW/temp}
%        \caption{temperature in different surfaces - does not work}
%        \label{fig:40}
%\end{figure}

\end{document}
